#include "levelcontainer.h"
#include <string.h>
#include "loadimage.h"

LevelContainer* LevelContainer::instance = 0;

LevelContainer::LevelContainer() {
	printf("Loading levels.\n");
	entranceInn.start = 200;
	entranceInn.level = &inn;
	entranceInn.image = LoadImage("Resources/inn.png");
	entranceInn.stop = entranceInn.start + entranceInn.image->w;
	
	entranceTraining.start = 800;
	entranceTraining.level = &training;
	entranceTraining.image = LoadImage("Resources/training.png");
	entranceTraining.stop = entranceTraining.start + entranceTraining.image->w;
	
	exitInn.start = 800;
	exitInn.level = &potcatCity;
	exitInn.image = LoadImage("Resources/door.png");
	exitInn.stop = exitInn.start + exitInn.image->w;
	
	exitTraining.start = 1000;
	exitTraining.level = &potcatCity;
	exitTraining.image = exitInn.image;
	exitTraining.stop = exitTraining.start + exitTraining.image->w;
	
	healer.start = 300;
	healer.image = LoadImage("Resources/healer.png");
	healer.stop = healer.start + healer.image->w;
	
	strcpy(inn.name, "the Inn");
	strcpy(inn.background, "Resources/background-inn.png");	
	
	strcpy(training.name, "the wilderness");
	strcpy(training.background, "Resources/background-training.png");	
	
	strcpy(potcatCity.name, "Potcat City");
	strcpy(potcatCity.background, "Resources/background.png");
	
	potcatCity.mapobjects[0] = &entranceInn;
	potcatCity.mapobjects[1] = &entranceTraining;
	potcatCity.mapobjects[2] = NULL;
	potcatCity.mapobjects[3] = NULL;
	potcatCity.mapobjects[4] = NULL;
	
	inn.mapobjects[0] = &healer;
	inn.mapobjects[1] = &exitInn;
	inn.mapobjects[2] = NULL;
	inn.mapobjects[3] = NULL;
	inn.mapobjects[4] = NULL;
	
	training.mapobjects[0] = &exitTraining;
	training.mapobjects[1] = NULL;
	training.mapobjects[2] = NULL;
	training.mapobjects[3] = NULL;
	training.mapobjects[4] = NULL;
	
	potcatCity.randomEncounters = false;
	inn.randomEncounters = false;
	training.randomEncounters = true;
	
	
	currentLevel = &potcatCity;
}

LevelContainer* LevelContainer::getInstance()
{
	if (!instance) {
		instance = new LevelContainer();
	}
	return instance;
}

void LevelContainer::changeLevel(Level *newlevel)
{
	currentLevel = newlevel;
}